diff -r e16bdc0054ce src/settings_gui.cpp
--- a/src/settings_gui.cpp
+++ b/src/settings_gui.cpp
@@ -36,6 +36,7 @@
 #include "textfile_gui.h"
 #include "stringfilter_type.h"
 #include "querystring_gui.h"
+#include "hotkeys.h"
 
 #include <vector>
 
@@ -570,6 +571,8 @@
 		missing_files = BaseMusic::GetUsedSet()->GetNumInvalid() == 0;
 		this->GetWidget<NWidgetCore>(WID_GO_BASE_MUSIC_STATUS)->SetDataTip(missing_files ? STR_EMPTY : STR_GAME_OPTIONS_BASE_MUSIC_STATUS, STR_NULL);
 	}
+
+	static HotkeyList hotkeys;
 };
 
 static const NWidgetPart _nested_game_options_widgets[] = {
@@ -653,11 +656,25 @@
 	EndContainer(),
 };
 
+static EventState GameOptionsWindowGlobalHotkeys(int hotkey) {
+	if (!ToggleFullScreen(!_fullscreen)) {
+		ShowErrorMessage(STR_ERROR_FULLSCREEN_FAILED, INVALID_STRING_ID, WL_ERROR);
+	}
+	return ES_HANDLED;
+}
+
+static Hotkey game_options_hotkeys[] = {
+	Hotkey((uint16)0, "toggle_fullscreen", WID_GO_FULLSCREEN_BUTTON),
+	HOTKEY_LIST_END
+};
+HotkeyList GameOptionsWindow::hotkeys("game_options", game_options_hotkeys, GameOptionsWindowGlobalHotkeys);
+
 static WindowDesc _game_options_desc(
 	WDP_CENTER, "settings_game", 0, 0,
 	WC_GAME_OPTIONS, WC_NONE,
 	0,
-	_nested_game_options_widgets, lengthof(_nested_game_options_widgets)
+	_nested_game_options_widgets, lengthof(_nested_game_options_widgets),
+	&GameOptionsWindow::hotkeys
 );
 
 /** Open the game options window. */
@@ -1524,6 +1541,10 @@
 				viewports->Add(new SettingEntry("gui.measure_tooltip"));
 				viewports->Add(new SettingEntry("gui.loading_indicators"));
 				viewports->Add(new SettingEntry("gui.show_track_reservation"));
+				viewports->Add(new SettingEntry("gui.cb_distance_check"));
+				viewports->Add(new SettingEntry("gui.old_depot_train_length_calc"));
+				viewports->Add(new SettingEntry("gui.enable_extra_tooltips"));
+				// viewports->Add(new SettingEntry("gui.polyrail_double_click"));
 			}
 
 			SettingsPage *construction = interface->Add(new SettingsPage(STR_CONFIG_SETTING_INTERFACE_CONSTRUCTION));
@@ -1544,6 +1565,8 @@
 			interface->Add(new SettingEntry("gui.timetable_in_ticks"));
 			interface->Add(new SettingEntry("gui.timetable_arrival_departure"));
 			interface->Add(new SettingEntry("gui.expenses_layout"));
+			interface->Add(new SettingEntry("gui.powerfund_money"));
+			interface->Add(new SettingEntry("gui.powerfund_houses"));
 		}
 
 		SettingsPage *advisors = main->Add(new SettingsPage(STR_CONFIG_SETTING_ADVISORS));
@@ -1560,6 +1583,7 @@
 			advisors->Add(new SettingEntry("gui.order_review_system"));
 			advisors->Add(new SettingEntry("gui.vehicle_income_warn"));
 			advisors->Add(new SettingEntry("gui.lost_vehicle_warn"));
+			advisors->Add(new SettingEntry("gui.runway_too_short_warn"));
 			advisors->Add(new SettingEntry("gui.show_finances"));
 			advisors->Add(new SettingEntry("news_display.economy"));
 			advisors->Add(new SettingEntry("news_display.subsidies"));
@@ -1602,6 +1626,26 @@
 
 		SettingsPage *vehicles = main->Add(new SettingsPage(STR_CONFIG_SETTING_VEHICLES));
 		{
+			/** Vehicle control page */
+			SettingsPage *veh_control = vehicles->Add(new SettingsPage(STR_CONFIG_SETTING_VEHICLES_CTRL));
+			{
+				veh_control->Add(new SettingEntry("gui.enable_ctrl_click_start_stop"));
+				veh_control->Add(new SettingEntry("gui.new_nonstop"));
+				veh_control->Add(new SettingEntry("gui.auto_noload_on_transfer"));
+				veh_control->Add(new SettingEntry("gui.auto_noload_on_unloadall"));
+			}
+
+			/** Order Shorcuts page */
+			SettingsPage *orders = veh_control->Add(new SettingsPage(STR_CONFIG_SETTING_ORDER_SHORTCUTS));
+			{
+				orders->Add(new SettingEntry("gui.goto_shortcuts_ctrl_lclick"));
+				orders->Add(new SettingEntry("gui.goto_shortcuts_shift_lclick"));
+				orders->Add(new SettingEntry("gui.goto_shortcuts_ctrlshift_lclick"));
+				orders->Add(new SettingEntry("gui.goto_shortcuts_alt_lclick"));
+				orders->Add(new SettingEntry("gui.goto_shortcuts_altshift_lclick"));
+				orders->Add(new SettingEntry("gui.goto_shortcuts_altctrl_lclick"));
+			}
+
 			SettingsPage *physics = vehicles->Add(new SettingsPage(STR_CONFIG_SETTING_VEHICLES_PHYSICS));
 			{
 				physics->Add(new SettingEntry("vehicle.train_acceleration_model"));
diff -r e16bdc0054ce src/settings_type.h
--- a/src/settings_type.h
+++ b/src/settings_type.h
@@ -79,6 +79,15 @@
 	bool   vehicle_income_warn;              ///< if a vehicle isn't generating income, show a warning
 	bool   show_finances;                    ///< show finances at end of year
 	bool   sg_new_nonstop;                   ///< ttdpatch compatible nonstop handling read from pre v93 savegames
+	bool   enable_ctrl_click_start_stop;     ///< allow ctrl+click to start or stop vehicles
+	uint8  goto_shortcuts_ctrl_lclick;       ///< goto action shortcut CTRL+LEFT-CLICK
+	uint8  goto_shortcuts_shift_lclick;      ///< goto action shortcut SHIFT+LEFT-CLICK
+	uint8  goto_shortcuts_ctrlshift_lclick;  ///< goto action shortcut CTRL+SHIFT+LEFT-CLICK
+	uint8  goto_shortcuts_alt_lclick;        ///< goto action shortcut ALT+LEFT-CLICK
+	uint8  goto_shortcuts_altshift_lclick;   ///< goto action shortcut ALT+SHIFT+LEFT-CLICK
+	uint8  goto_shortcuts_altctrl_lclick;    ///< goto action shortcut ALT+CTRL+LEFT-CLICK
+	bool   auto_noload_on_transfer;          ///< automatically set no-loading when ordering to transfer all cargo
+	bool   auto_noload_on_unloadall;         ///< automatically set no-loading when ordering to unload all cargo
 	bool   new_nonstop;                      ///< ttdpatch compatible nonstop handling
 	uint8  stop_location;                    ///< what is the default stop location of trains?
 	uint8  auto_scrolling;                   ///< scroll when moving mouse to the edge (see #ViewportAutoscrolling)
@@ -158,6 +167,16 @@
 	bool   newgrf_show_old_versions;         ///< whether to show old versions in the NewGRF list
 	uint8  newgrf_default_palette;           ///< default palette to use for NewGRFs without action 14 palette information
 
+	bool   old_depot_train_length_calc;      ///< display vehicle length in whole numbers - old style
+	uint8  cb_distance_check;                ///< zoning cb distance
+	bool   enable_extra_tooltips;            ///< enable extra tooltips when hovering over various elements
+	bool   polyrail_double_click;            ///< finish polyrail with mouse double click
+	bool   show_industry_forbidden_tiles;    ///< higlight areas where industry placement is forbidden regardless of terrain
+	bool   runway_too_short_warn;            ///< warn about aircrafts using too short runways
+
+	uint32 powerfund_money;                  ///< minimum amount of money for powerfund to work
+	uint16 powerfund_houses;                 ///< powerfunding maximum houses limit
+
 	/**
 	 * Returns true when the user has sufficient privileges to edit newgrfs on a running game
 	 * @return whether the user has sufficient privileges to edit newgrfs in an existing game
diff -r e16bdc0054ce src/smallmap_gui.cpp
--- a/src/smallmap_gui.cpp
+++ b/src/smallmap_gui.cpp
@@ -896,7 +896,7 @@
 				y < dpi->top + dpi->height) {
 			/* And draw it. */
 			SetDParam(0, t->index);
-			DrawString(x, x + t->cache.sign.width_small, y, STR_SMALLMAP_TOWN);
+			DrawString(x, x + t->cache.sign.width_small, y, t->larger_town ? STR_SMALLMAP_TOWN_LARGE : STR_SMALLMAP_TOWN);
 		}
 	}
 }
diff -r e16bdc0054ce src/station.cpp
--- a/src/station.cpp
+++ b/src/station.cpp
@@ -19,6 +19,7 @@
 #include "news_func.h"
 #include "aircraft.h"
 #include "vehiclelist.h"
+#include "town.h"
 #include "core/pool_func.hpp"
 #include "station_base.h"
 #include "roadstop_base.h"
@@ -75,6 +76,15 @@
  */
 Station::~Station()
 {
+	Town *t;
+	FOR_ALL_TOWNS(t) {
+		// Using poiter comparison instead of cycling cargos
+		if (t->ad_ref_goods_entry >= this->goods &&
+		 	   t->ad_ref_goods_entry < this->goods + NUM_CARGO) {
+		    t->ad_ref_goods_entry = NULL;
+		}
+	}
+
 	if (CleaningPool()) {
 		for (CargoID c = 0; c < NUM_CARGO; c++) {
 			this->goods[c].cargo.OnCleanPool();
diff -r e16bdc0054ce src/station_gui.cpp
--- a/src/station_gui.cpp
+++ b/src/station_gui.cpp
@@ -1282,6 +1282,7 @@
 
 	int scroll_to_row;                  ///< If set, scroll the main viewport to the station pointed to by this row.
 	int grouping_index;                 ///< Currently selected entry in the grouping drop down.
+	int ratings_list_y = 0;             ///< Y coordinate of first line in station ratings panel.
 	Mode current_mode;                  ///< Currently selected display mode of cargo view.
 	Grouping groupings[NUM_COLUMNS];    ///< Grouping modes for the different columns.
 
@@ -1813,7 +1814,7 @@
 	 * @param r Rectangle of the widget.
 	 * @return Number of lines needed for drawing the cargo ratings.
 	 */
-	int DrawCargoRatings(const Rect &r) const
+	int DrawCargoRatings(const Rect &r)
 	{
 		const Station *st = Station::Get(this->window_number);
 		int y = r.top + WD_FRAMERECT_TOP;
@@ -1827,6 +1828,7 @@
 		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_RIGHT, y, STR_STATION_VIEW_SUPPLY_RATINGS_TITLE);
 		y += FONT_HEIGHT_NORMAL;
 
+		this->ratings_list_y = y;
 		const CargoSpec *cs;
 		FOR_ALL_SORTED_STANDARD_CARGOSPECS(cs) {
 			const GoodsEntry *ge = &st->goods[cs->Index()];
@@ -2060,6 +2062,28 @@
 		this->vscroll->SetCapacityFromWidget(this, WID_SV_WAITING, WD_FRAMERECT_TOP + WD_FRAMERECT_BOTTOM);
 	}
 
+	virtual void OnHover(Point pt, int widget)
+	{
+		if (widget != WID_SV_ACCEPT_RATING_LIST ||
+		    	this->GetWidget<NWidgetCore>(WID_SV_ACCEPTS_RATINGS)->widget_data == STR_STATION_VIEW_RATINGS_BUTTON)
+			Window::OnHover(pt, widget);
+
+		int ofs_y = pt.y - this->ratings_list_y;
+		if (ofs_y < 0) return;
+
+		const Station *st = Station::Get(this->window_number);
+		const CargoSpec *cs;
+		FOR_ALL_SORTED_STANDARD_CARGOSPECS(cs) {
+			const GoodsEntry *ge = &st->goods[cs->Index()];
+			if (!ge->HasRating()) continue;
+			ofs_y -= FONT_HEIGHT_NORMAL;
+			if (ofs_y < 0) {
+				GuiShowStationRatingTooltip(this, st, cs);
+				break;
+			}
+		}
+	}
+
 	/**
 	 * Some data on this window has become invalid. Invalidate the cache for the given cargo if necessary.
 	 * @param data Information about the changed data. If it's a valid cargo ID, invalidate the cargo data.
@@ -2234,16 +2258,17 @@
  * @tparam T The type of station to join with
  */
 template <class T>
-struct SelectStationWindow : Window {
+struct SelectStationWindow : WindowPopup {
 	CommandContainer select_station_cmd; ///< Command to build new station
 	TileArea area; ///< Location of new station
 	Scrollbar *vscroll;
 
 	SelectStationWindow(WindowDesc *desc, const CommandContainer &cmd, TileArea ta) :
-		Window(desc),
+		WindowPopup(desc, WPUT_WIDGET_RELATIVE),
 		select_station_cmd(cmd),
 		area(ta)
 	{
+		this->wpu_widget = WID_JS_PANEL;
 		this->CreateNestedTree();
 		this->vscroll = this->GetScrollbar(WID_JS_SCROLLBAR);
 		this->GetWidget<NWidgetCore>(WID_JS_CAPTION)->widget_data = T::EXPECTED_FACIL == FACIL_WAYPOINT ? STR_JOIN_WAYPOINT_CAPTION : STR_JOIN_STATION_CAPTION;
diff -r e16bdc0054ce src/table/settings.ini
--- a/src/table/settings.ini
+++ b/src/table/settings.ini
@@ -3936,5 +3936,172 @@
 strval   = STR_CONFIG_SETTING_RIGHT_MOUSE_BTN_EMU_COMMAND
 cat      = SC_BASIC
 
+; //MODGUI *********************************
+[SDTC_BOOL]
+var      = gui.enable_ctrl_click_start_stop
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = true
+str      = STR_CONFIG_SETTING_CTRL_ENABLE_CTRLCLICK_STARTSTOP
+
+[SDTC_BOOL]
+var      = gui.auto_noload_on_transfer
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = true
+str      = STR_CONFIG_SETTING_AUTOSET_NOLOAD_ON_TRANSFER
+
+[SDTC_BOOL]
+var      = gui.auto_noload_on_unloadall
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = false
+str      = STR_CONFIG_SETTING_AUTOSET_NOLOAD_ON_UNLOAD
+
+[SDTC_VAR]
+var      = gui.goto_shortcuts_ctrl_lclick
+type     = SLE_UINT8
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+guiflags = SGF_MULTISTRING
+def      = 1
+min      = 0
+max      = 6
+interval = 1
+str      = STR_CONFIG_SETTING_CTRL_GOTOSHORTCUT_CTRLLCLICK
+strval   = STR_CONFIG_SETTING_CTRL_GOTOSHORTOPTS_NONE
+proc     = RedrawScreen
+cat      = SC_BASIC
+
+[SDTC_VAR]
+var      = gui.goto_shortcuts_shift_lclick
+type     = SLE_UINT8
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+guiflags = SGF_MULTISTRING
+def      = 0
+min      = 0
+max      = 6
+interval = 1
+str      = STR_CONFIG_SETTING_CTRL_GOTOSHORTCUT_SHIFTLCLICK
+strval   = STR_CONFIG_SETTING_CTRL_GOTOSHORTOPTS_NONE
+proc     = RedrawScreen
+cat      = SC_BASIC
+
+[SDTC_VAR]
+var      = gui.goto_shortcuts_ctrlshift_lclick
+type     = SLE_UINT8
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+guiflags = SGF_MULTISTRING
+def      = 0
+min      = 0
+max      = 6
+interval = 1
+str      = STR_CONFIG_SETTING_CTRL_GOTOSHORTCUT_CTRLSHIFTLCLICK
+strval   = STR_CONFIG_SETTING_CTRL_GOTOSHORTOPTS_NONE
+proc     = RedrawScreen
+cat      = SC_BASIC
+
+[SDTC_VAR]
+var      = gui.goto_shortcuts_alt_lclick
+type     = SLE_UINT8
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+guiflags = SGF_MULTISTRING
+def      = 0
+min      = 0
+max      = 6
+interval = 1
+str      = STR_CONFIG_SETTING_CTRL_GOTOSHORTCUT_ALTLCLICK
+strval   = STR_CONFIG_SETTING_CTRL_GOTOSHORTOPTS_NONE
+proc     = RedrawScreen
+cat      = SC_BASIC
+
+[SDTC_VAR]
+var      = gui.goto_shortcuts_altshift_lclick
+type     = SLE_UINT8
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+guiflags = SGF_MULTISTRING
+def      = 0
+min      = 0
+max      = 6
+interval = 1
+str      = STR_CONFIG_SETTING_CTRL_GOTOSHORTCUT_ALTSHIFTCLICK
+strval   = STR_CONFIG_SETTING_CTRL_GOTOSHORTOPTS_NONE
+proc     = RedrawScreen
+cat      = SC_BASIC
+
+[SDTC_VAR]
+var      = gui.goto_shortcuts_altctrl_lclick
+type     = SLE_UINT8
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+guiflags = SGF_MULTISTRING
+def      = 0
+min      = 0
+max      = 6
+interval = 1
+str      = STR_CONFIG_SETTING_CTRL_GOTOSHORTCUT_CTRLALTLCLICK
+strval   = STR_CONFIG_SETTING_CTRL_GOTOSHORTOPTS_NONE
+proc     = RedrawScreen
+cat      = SC_BASIC
+
+[SDTC_BOOL]
+var      = gui.old_depot_train_length_calc
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = true
+str      = STR_OLD_DEPOT_TRAINT_LENGTH
+
+[SDTC_VAR]
+var      = gui.cb_distance_check
+type     = SLE_UINT8
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = 25
+min      = 0
+max      = 100
+interval = 5
+str      = STR_CB_DISTANCE_CHECK
+strval   = STR_JUST_COMMA
+proc     = RedrawScreen
+
+[SDTC_BOOL]
+var      = gui.enable_extra_tooltips
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = true
+str      = STR_CONFIG_SETTING_ENABLE_EXTRA_TOOLTIPS
+
+[SDTC_BOOL]
+var      = gui.polyrail_double_click
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = false
+str      = STR_CONFIG_SETTING_POLYRAIL_DOUBLECLICK_TOOLTIPS
+
+[SDTC_BOOL]
+var      = gui.show_industry_forbidden_tiles
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = false
+cat      = SC_BASIC
+
+[SDTC_BOOL]
+var      = gui.runway_too_short_warn
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = true
+str      = STR_CONFIG_SETTING_WARN_IF_RUNWAY_IS_TOO_SHORT
+
+[SDTC_VAR]
+var      = gui.powerfund_money
+type     = SLE_UINT
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+guiflags = SGF_CURRENCY
+def      = 200000
+min      = 0
+max      = 2000000
+str      = STR_CONFIG_SETTING_POWERFUND_MONEY
+strval   = STR_JUST_CURRENCY_LONG
+
+[SDTC_VAR]
+var      = gui.powerfund_houses
+type     = SLE_UINT16
+flags    = SLF_NOT_IN_SAVE | SLF_NO_NETWORK_SYNC
+def      = 10000
+min      = 0
+max      = 10000
+interval = 10
+str      = STR_CONFIG_SETTING_POWERFUND_HOUSES
+strval   = STR_JUST_COMMA
+
 [SDT_END]
 
diff -r e16bdc0054ce src/table/sprites.h
--- a/src/table/sprites.h
+++ b/src/table/sprites.h
@@ -296,8 +296,22 @@
 static const SpriteID SPR_PALETTE_BASE = SPR_EMPTY_BOUNDING_BOX + EMPTY_BOUNDING_BOX_SPRITE_COUNT;
 static const uint16 PALETTE_SPRITE_COUNT = 1;
 
+/* zoning stuff */
+static const SpriteID SPR_INNER_HIGHLIGHT_BASE      = SPR_PALETTE_BASE + PALETTE_SPRITE_COUNT;
+static const SpriteID SPR_IMG_COMPANY_CARGO         = SPR_INNER_HIGHLIGHT_BASE + 19;
+static const SpriteID SPR_IMG_COMPANY_GOAL          = SPR_INNER_HIGHLIGHT_BASE + 20;
+static const SpriteID SPR_PALETTE_ZONING_RED        = SPR_INNER_HIGHLIGHT_BASE + 21;
+static const SpriteID SPR_PALETTE_ZONING_GREEN      = SPR_INNER_HIGHLIGHT_BASE + 22;
+static const SpriteID SPR_PALETTE_ZONING_BLACK      = SPR_INNER_HIGHLIGHT_BASE + 23;
+static const SpriteID SPR_PALETTE_ZONING_LIGHT_BLUE = SPR_INNER_HIGHLIGHT_BASE + 24;
+static const SpriteID SPR_PALETTE_ZONING_ORANGE     = SPR_INNER_HIGHLIGHT_BASE + 25;
+static const SpriteID SPR_PALETTE_ZONING_WHITE      = SPR_INNER_HIGHLIGHT_BASE + 26;
+static const SpriteID SPR_PALETTE_ZONING_YELLOW     = SPR_INNER_HIGHLIGHT_BASE + 27;
+static const SpriteID SPR_PALETTE_ZONING_PURPLE     = SPR_INNER_HIGHLIGHT_BASE + 28;
+static const SpriteID SPR_INNER_HIGHLIGHT_COUNT     = 29;
+
 /* From where can we start putting NewGRFs? */
-static const SpriteID SPR_NEWGRFS_BASE = SPR_PALETTE_BASE + PALETTE_SPRITE_COUNT;
+static const SpriteID SPR_NEWGRFS_BASE = SPR_INNER_HIGHLIGHT_BASE + SPR_INNER_HIGHLIGHT_COUNT;
 
 /* Manager face sprites */
 static const SpriteID SPR_GRADIENT = 874; // background gradient behind manager face
diff -r e16bdc0054ce src/tile_cmd.h
--- a/src/tile_cmd.h
+++ b/src/tile_cmd.h
@@ -64,6 +64,7 @@
 	uint64 dparam[2];           ///< Parameters of the \a str string
 	uint16 rail_speed;          ///< Speed limit of rail (bridges and track)
 	uint16 road_speed;          ///< Speed limit of road (bridges)
+	uint16 population;
 };
 
 /**
diff -r e16bdc0054ce src/tilehighlight_func.h
--- a/src/tilehighlight_func.h
+++ b/src/tilehighlight_func.h
@@ -14,6 +14,8 @@
 
 #include "gfx_type.h"
 #include "tilehighlight_type.h"
+#include "track_type.h"
+#include "industry_type.h"
 
 void PlaceProc_DemolishArea(TileIndex tile);
 bool GUIPlaceProcDragXY(ViewportDragDropSelectionProcess proc, TileIndex start_tile, TileIndex end_tile);
@@ -30,6 +32,12 @@
 
 void UpdateTileSelection();
 
+void StoreRailPlacementEndpoints(TileIndex start_tile, TileIndex end_tile, Track start_track, bool bidirectional = true);
+void ResetRailPlacementSnapping();
+bool CurrentlySnappingRailPlacement();
+
+void SetIndustryForbiddenTilesHighlight(IndustryType type);
+
 extern TileHighlightData _thd;
 
 #endif /* TILEHIGHLIGHT_FUNC_H */
diff -r e16bdc0054ce src/tilehighlight_type.h
--- a/src/tilehighlight_type.h
+++ b/src/tilehighlight_type.h
@@ -28,6 +28,8 @@
 	HT_RAIL      = 0x080, ///< autorail (one piece), lower bits: direction
 	HT_VEHICLE   = 0x100, ///< vehicle is accepted as target as well (bitmask)
 	HT_DIAGONAL  = 0x200, ///< Also allow 'diagonal rectangles'. Only usable in combination with #HT_RECT or #HT_POINT.
+	HT_POLY      = 0x400, ///< polyline mode; connect highlighted track with previous one
+	HT_NEW_POLY  = 0xC00, ///< start completly new polyline; implies #HT_POLY
 	HT_DRAG_MASK = 0x0F8, ///< Mask for the tile drag-type modes.
 
 	/* lower bits (used with HT_LINE and HT_RAIL):
@@ -54,11 +56,15 @@
 
 	Point new_pos;       ///< New value for \a pos; used to determine whether to redraw the selection.
 	Point new_size;      ///< New value for \a size; used to determine whether to redraw the selection.
+	Point new_offs;      ///< New value for \a offs; used to determine whether to redraw the selection.
 	Point new_outersize; ///< New value for \a outersize; used to determine whether to redraw the selection.
 	byte dirty;          ///< Whether the build station window needs to redraw due to the changed selection.
 
 	Point selstart;      ///< The location where the dragging started.
 	Point selend;        ///< The location where the drag currently ends.
+	Point selstart2;     ///< The location where the second segment of a polyline track starts.
+	Point selend2;       ///< The location where the second segment of a polyline track ends.
+	HighLightStyle dir2; ///< Direction of the second segment of a polyline track, HT_DIR_END if second segment is not selected. HT_LINE drawstyle.
 	byte sizelimit;      ///< Whether the selection is limited in length, and what the maximum length is.
 
 	HighLightStyle drawstyle;      ///< Lower bits 0-3 are reserved for detailed highlight information.
